function Z1 = compute_Z1_PO_MG(x,par,m,A,nu)

d = 4;

tau = x(1);
eta = x(2:4);
a = x(5:end);

N = length(a)/(m*d) - 1; % N+1 is the number of Chebyshev coefficients per iterate
a = reshape(a,d*(N+1),m);

gamma = par(1);
beta = par(2);
rho = par(3);

inu = intval(nu);

hat_z1_a = intval(zeros(d*(N+1),m));

T = diag(ones(1,N),-1) - diag(ones(1,N),1) ; T(1,2)=0;
Lambda_inv = [1 (1:N).^(-1)]';

hat_z1_tail = intval(zeros(4,m));

for j=1:m
    
    aj = a(:,(1-isequal(j,m))*j+1);
    bj = a(:,j);
    
    a1 = aj(1:N+1); a2 = aj(N+2:2*N+2); a3 = aj(2*N+3:3*N+3); a4 = aj(3*N+4:4*N+4); b2 = bj(N+2:2*N+2);
   
    %%%%%%%%%
    % phi_a %
    %%%%%%%%%
    
    phi_a21 = -gamma*[rig_convolution([a2 a4]);zeros(N,1)] + rho*gamma*rig_convolution([a2 a2 a3]);
    phi_a22 = -gamma*[rig_convolution([a1 a4]);zeros(N,1)] + beta*[rig_convolution([a4 b2]);zeros(N,1)] + 2*rho*gamma*rig_convolution([a1 a2 a3]) - 2*rho*beta*rig_convolution([a2 a3 b2]);
    phi_a23 = rho*gamma*rig_convolution([a1 a2 a2]) - rho*beta*rig_convolution([a2 a2 b2]);
    phi_a24 = -gamma*rig_convolution([a1 a2]) + beta*rig_convolution([a2 b2]);
    
    phi_a31 = -gamma*(rho-2)*rig_convolution([a3 a4]);
    phi_a33 = -gamma*(rho-2)*rig_convolution([a1 a4]) + beta*(rho-2)*rig_convolution([a4 b2]);
    phi_a34 = -gamma*(rho-2)*rig_convolution([a1 a3]) + beta*(rho-2)*rig_convolution([a3 b2]);
    
    phi_a41 = gamma*rig_convolution([a4 a4]);
    phi_a44 = 2*gamma*rig_convolution([a1 a4]) - 2*beta*rig_convolution([a4 b2]);
    
    %%%%%%%%%
    % phi_b %
    %%%%%%%%%
    
    phi_b22 = beta*[rig_convolution([a2 a4]);zeros(N,1)] - rho*beta*rig_convolution([a2 a2 a3]);
    phi_b32 = beta*(rho-2)*rig_convolution([a3 a4]);
    phi_b42 = -beta*rig_convolution([a4 a4]);
    
    %%%%%%%%%%%%
    % hat_z1_a %
    %%%%%%%%%%%%
    
    hat_z1_a2 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_a21,N,nu) + compute_Psi_k(phi_a22,N,nu) + compute_Psi_k(phi_a23,N,nu) + compute_Psi_k(phi_a24,N,nu)); hat_z1_a2(1) = 1/inu^(N+1);
    hat_z1_a3 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_a31,N,nu) + compute_Psi_k(phi_a33,N,nu) + compute_Psi_k(phi_a34,N,nu)); hat_z1_a3(1) = 1/inu^(N+1);
    hat_z1_a4 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_a41,N,nu) + compute_Psi_k(phi_a44,N,nu)); hat_z1_a4(1) = 1/inu^(N+1);
    
    hat_z1_b2 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_b22,N,nu)); hat_z1_b2(1) = 1/inu^(N+1);
    hat_z1_b3 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_b32,N,nu)); hat_z1_b3(1) = 1/inu^(N+1);
    hat_z1_b4 = (tau/4)*Lambda_inv.*abs(T)*(compute_Psi_k(phi_b42,N,nu)); hat_z1_b4(1) = 1/inu^(N+1);
    
    hat_z1_a(:,j) = [zeros(N+1,1);hat_z1_a2;hat_z1_a3;hat_z1_a4] + [zeros(N+1,1);hat_z1_b2;hat_z1_b3;hat_z1_b4];
    
    %%%%%%%%%%%%%%%
    % hat_z1_tail %
    %%%%%%%%%%%%%%%
    
    a1a2a4 = rig_convolution([a1 a2 a4]);
    a1a3a4 = rig_convolution([a1 a3 a4]);
    a1a4a4 = rig_convolution([a1 a4 a4]);
    a2a4b2 = rig_convolution([a2 a4 b2]);
    a3a4b2 = rig_convolution([a3 a4 b2]);
    a4a4b2 = rig_convolution([a4 a4 b2]);
    a1a2a2a3 = rig_convolution([a1 a2 a2 a3]);
    a2a2a3b2 = rig_convolution([a2 a2 a3 b2]);
    
    phi1 = -gamma*a1 + beta*b2;
    phi2 = -gamma*[a1a2a4;zeros(N,1)] + beta*[a2a4b2;zeros(N,1)] + rho*gamma*a1a2a2a3 - rho*beta*a2a2a3b2 + [eta(1);zeros(4*N,1)];
    phi3 = -gamma*(rho-2)*a1a3a4 + beta*(rho-2)*a3a4b2 + [eta(2);zeros(3*N,1)];
    phi4 = gamma*a1a4a4 - beta*a4a4b2 + [eta(3);zeros(3*N,1)];
    
    hat_z1_tail(1,j) = 1/(4*(N+1))*(inu+1/inu)*(nu_norm_a(phi1,nu) + tau*gamma + tau*beta) ;
    hat_z1_tail(2,j) = 1/(4*(N+1))*(inu+1/inu)*(nu_norm_a(phi2,nu) + tau*(nu_norm_a(phi_a21,nu)+nu_norm_a(phi_a22,nu)+nu_norm_a(phi_a23,nu)+nu_norm_a(phi_a24,nu)) + tau*nu_norm_a(phi_b22,nu) + tau );
    hat_z1_tail(3,j) = 1/(4*(N+1))*(inu+1/inu)*(nu_norm_a(phi3,nu) + tau*(nu_norm_a(phi_a31,nu)+nu_norm_a(phi_a33,nu)+nu_norm_a(phi_a34,nu)) + tau*nu_norm_a(phi_b32,nu) + tau );
    hat_z1_tail(4,j) = 1/(4*(N+1))*(inu+1/inu)*(nu_norm_a(phi4,nu) + tau*(nu_norm_a(phi_a41,nu)+nu_norm_a(phi_a44,nu)) + tau*nu_norm_a(phi_b42,nu) + tau );

end

hat_z1_a = reshape(hat_z1_a,d*m*(N+1),1);

hat_z1 = [1/inu^(N+1)*ones(4,1);hat_z1_a];

Az1_finite = abs(A)*hat_z1;

Z1 = max(sup(Az1_finite(1:4)));

Az1_finite(1:4) = [];

Az1_finite = reshape(Az1_finite,d*(N+1),m);

omega = [1 2*nu.^abs(1:N)]';

for j=1:m
    
    Az1j = Az1_finite(:,j);
    Az1j1 = Az1j(1:N+1);
    Az1j2 = Az1j(N+2:2*N+2);
    Az1j3 = Az1j(2*N+3:3*N+3);
    Az1j4 = Az1j(3*N+4:4*N+4);
    
    nu_norm_Az1j1 = sup(sum(abs(Az1j1).*omega) + hat_z1_tail(1,j) );
    nu_norm_Az1j2 = sup(sum(abs(Az1j2).*omega) + hat_z1_tail(2,j));
    nu_norm_Az1j3 = sup(sum(abs(Az1j3).*omega) + hat_z1_tail(3,j));
    nu_norm_Az1j4 = sup(sum(abs(Az1j4).*omega) + hat_z1_tail(4,j));
    
    Z1_temp = max([nu_norm_Az1j1 nu_norm_Az1j2 nu_norm_Az1j3 nu_norm_Az1j4]);
    
    Z1 = max(Z1,Z1_temp);
    
end

end