function Z2 = compute_Z2_PO_MG(x,par,m,A,nu)

d = 4;
r_s = 1e-6;

tau = x(1);
a = x(5:end);

N = length(a)/(m*d) - 1; % N+1 is the number of Chebyshev coefficients per iterate
a = reshape(a,d*(N+1),m);

gamma = par(1);
beta = par(2);
rho = par(3);

nu = intval(nu);

norm_tA = tilde_operator_norm(A,N,m,nu,1/(N+1));
z2 = 0;

for j=1:m
    
    aj = a(:,(1-isequal(j,m))*j+1);
    bj = a(:,j);
    
    a1 = aj(1:N+1); a2 = aj(N+2:2*N+2); a3 = aj(2*N+3:3*N+3); a4 = aj(3*N+4:4*N+4); b2 = bj(N+2:2*N+2);
   
    %%%%%%%
    % psi %
    %%%%%%%
    
    psi = intval(zeros(4,1));
    psi(2,1) = gamma*z2_3(a1,a2,a4,r_s,nu) + beta*z2_3(a2,a4,b2,r_s,nu) + rho*gamma*z2_4(a1,a2,a2,a3,r_s,nu) + rho*beta*z2_4(a2,a2,a3,b2,r_s,nu);
    psi(3,1) = gamma*(rho-2)*z2_3(a1,a3,a4,r_s,nu) + beta*(rho-2)*z2_3(a3,a4,b2,r_s,nu);
    psi(4,1) = gamma*z2_3(a1,a4,a4,r_s,nu) + beta*z2_3(a4,a4,b2,r_s,nu);
    
    psi_ab = intval(zeros(4,1));    
    
    psi_ab(2,1) = (gamma+beta)*z2_2(a2,a4,r_s,nu) + rho*(gamma+beta)*z2_3(a2,a2,a4,r_s,nu) ...
                  + gamma*z2_2(a1,a4,r_s,nu) + beta*z2_2(a4,b2,r_s,nu) + 2*rho*gamma*z2_3(a1,a2,a3,r_s,nu) + 2*rho*beta*z2_3(a2,a3,b2,r_s,nu) ...
                  + rho*gamma*z2_3(a1,a2,a2,r_s,nu) + rho*beta*z2_3(a2,a2,b2,r_s,nu) ...
                  + gamma*z2_2(a1,a2,r_s,nu) + beta*z2_2(a2,b2,r_s,nu);
              
    psi_ab(3,1) = (gamma+beta)*(rho-2)*z2_2(a3,a4,r_s,nu) ...
                  + gamma*(rho-2)*z2_2(a1,a4,r_s,nu) + beta*(rho-2)*z2_2(a4,b2,r_s,nu) ...
                  + gamma*(rho-2)*z2_2(a1,a3,r_s,nu) + beta*(rho-2)*z2_2(a3,b2,r_s,nu);
              
    psi_ab(4,1) = (gamma+beta)*z2_2(a4,a4,r_s,nu) + 2*gamma*z2_2(a1,a4,r_s,nu) + 2*beta*z2_2(a4,b2,r_s,nu);
        
    xi_1 = (gamma+beta);
    
    xi_2 = (gamma+beta)*z1_2(a2,a4,r_s,nu) + rho*(gamma+beta)*z1_3(a2,a2,a4,r_s,nu) ...
        + gamma*z1_2(a1,a4,r_s,nu) + beta*z1_2(a4,b2,r_s,nu) + 2*rho*gamma*z1_3(a1,a2,a3,r_s,nu) + 2*rho*beta*z1_3(a2,a3,b2,r_s,nu) ...
        + rho*gamma*z1_3(a1,a2,a2,r_s,nu) + rho*beta*z1_3(a2,a2,b2,r_s,nu) + gamma*z1_2(a1,a2,r_s,nu) + beta*z1_2(a2,b2,r_s,nu);
    
    xi_3 = (gamma+beta)*(rho-2)*z1_2(a3,a4,r_s,nu) ...
        + gamma*(rho-2)*z1_2(a1,a4,r_s,nu) ...
        + beta*(rho-2)*z1_2(a4,b2,r_s,nu) ...
        + gamma*(rho-2)*z1_2(a1,a3,r_s,nu) ...
        + beta*(rho-2)*z1_2(a3,b2,r_s,nu);
    
    xi_4 = (gamma+beta)*z1_2(a4,a4,r_s,nu) ...
        + 2*gamma*z1_2(a1,a4,r_s,nu) ...
        + 2*beta*z1_2(a4,b2,r_s,nu);
    
    z2_temp = max(sup([xi_1;psi(2,1)+tau*psi_ab(2,1)+xi_2;psi(3,1)+tau*psi_ab(3,1)+xi_3;psi(4,1)+tau*psi_ab(4,1)+xi_4]));
    
    disp(z2_temp)
    
    z2 = max(z2_temp,z2);
    
end

Z2 = sup(norm_tA*z2/4);

end