function norm_x = nu_norm_x(x,m,nu)

tau = x(1);
eta = x(2:4);
a = x(5:end);
d = 4;

N = length(a)/(m*d) - 1; % N+1 is the number of Chebyshev coefficients per iterate
a = reshape(a,d*(N+1),m);

omega = [1 2*nu.^abs(1:N)]';

norm_aj = zeros(m,1);

for j=1:m
    aj = a(:,j);
    a1 = aj(1:N+1); a2 = aj(N+2:2*N+2); a3 = aj(2*N+3:3*N+3); a4 = aj(3*N+4:4*N+4);
    norm_aj(j) = max([sup(sum(abs(a1).*omega)) sup(sum(abs(a2).*omega)) sup(sum(abs(a3).*omega)) sup(sum(abs(a4).*omega))]);
end

norm_x = max([sup(abs(tau));sup(abs(eta));norm_aj(j)]);

end
