function x = padding_PO_MG(x,m,N1)

tau = x(1);
eta = x(2:4);
a = x(5:end);
d = 4;

N = length(a)/(m*d) - 1; % N+1 is the number of Chebyshev coefficients per iterate
a = reshape(a,d*(N+1),m);

if isintval(x)
    a_ext = intval(zeros(d*(N+N1+1),m));
else
    a_ext = zeros(d*(N+N1+1),m);
end

if N1>0 
    
    for j=1:m
        
        aj = a(:,j);
        aj1 = [aj(1:N+1);zeros(N1,1)];
        aj2 = [aj(N+2:2*N+2);zeros(N1,1)];
        aj3 = [aj(2*N+3:3*N+3);zeros(N1,1)];
        aj4 = [aj(3*N+4:4*N+4);zeros(N1,1)];
        a_ext(:,j) = [aj1;aj2;aj3;aj4];
        
    end
    
    a_ext = reshape(a_ext,d*(N+N1+1)*m,1);
    x = [tau;eta;a_ext];
    
else
        
    for j=1:m
        
        aj = a(:,j);
        aj1 = aj(1:N+1+N1);
        aj2 = aj(N+2:2*N+2+N1);
        aj3 = aj(2*N+3:3*N+3+N1);
        aj4 = aj(3*N+4:4*N+4+N1);
        a_ext(:,j) = [aj1;aj2;aj3;aj4];
        
    end
    
    a_ext = reshape(a_ext,d*(N+1+N1)*m,1);
    x = [tau;eta;a_ext];
    
end

end