function plot_profile(a,t,color)

N = length(a) - 1;

t_min = t(1); t_max = t(end); 
t = (t_min:.001:t_max);
alpha = 2/(t_max-t_min); beta = 1 - alpha*t_max;
tau = alpha*t+beta; % maps the interval [t_min,t_max] to [-1,1]
theta = acos(tau);

n = length(tau);
u = zeros(1,n);

k = (1:N)';

for j = 1:n
    u(j) = a(1) + 2*sum(a(k+1).*cos(k*theta(j)));
end

plot(t,u,'color',color, 'LineWidth', 3)

axis tight
set(gca,'FontSize',20)
xlabel('$$t$$', 'Interpreter', 'latex', 'FontSize', 30)



end