function [I,success] = rad_poly_m_steps_PO_MG(x,par,m,nu)

d = 4;

N = (length(x)-4)/(m*d) - 1; % N+1 is the number of Chebyshev coefficients per iterate

disp('Computing iDF...')
iDF = int_DF_PO_mg_up_chebyshev(x,par,m);

disp('Inverting numerically DF...')
A = mid(iDF)\eye(m*d*(N+1)+4);
iA = intval(A);

%%%%%%%%%%
%%% Y0 %%%
%%%%%%%%%%

disp('Computing Y0...')
Y0 = compute_Y0_PO_MG(x,par,m,N,iA,nu);
disp(['Y0 = ',num2str(Y0)])

%%%%%%%%%%
%%% Z0 %%%
%%%%%%%%%%

disp('Computing Z0...')
B = eye(m*d*(N+1)+4) - iA*iDF; tail = 0 ;
Z0 = operator_norm(B,N,m,nu,tail);
disp(['Z0 = ',num2str(Z0)])

%%%%%%%%%%
%%% Z1 %%%
%%%%%%%%%%

disp('Computing Z1...');
Z1 = compute_Z1_PO_MG(x,par,m,iA,nu);
disp(['Z1 = ',num2str(Z1)])

%%%%%%%%%%
%%% Z2 %%%
%%%%%%%%%%

disp('Computing Z2...');
Z2 = compute_Z2_PO_MG(x,par,m,iA,nu);
disp(['Z2 = ',num2str(Z2)])

%%%%%%%%%%%%%%%%%%%%
% Radii polynomial %
%%%%%%%%%%%%%%%%%%%%

iY0 = intval(Y0);
iZ0 = intval(Z0);
iZ1 = intval(Z1);
iZ2 = intval(Z2);

DELTA = (1-iZ0-iZ1)^2 - 2*iY0*iZ2;

if inf(DELTA) > 0 && sup(iZ0+iZ1)<1
    rmin = sup((1-iZ0-iZ1 - sqrt(DELTA))/Z2); 
    rmax = inf((1-iZ0-iZ1)/iZ2); 
    I = [rmin rmax];
    success=1;
else
    success=0;
    I=[-1 -1];
end

end

