function normA = tilde_operator_norm(A,N,m,nu,tail)

tail = (2*nu+1/nu)*tail;

i_tau = 1;
i_eta = (2:4);

i_aj1 = zeros(m,N+1); i_aj1(1,:) = 4 + (1:N+1);
i_aj2 = zeros(m,N+1); i_aj2(1,:) = i_aj1(1,N+1) + (1:N+1);
i_aj3 = zeros(m,N+1); i_aj3(1,:) = i_aj2(1,N+1) + (1:N+1);
i_aj4 = zeros(m,N+1); i_aj4(1,:) = i_aj3(1,N+1) + (1:N+1);

for j = 1:m-1
    i_aj1(j+1,:) = i_aj4(j,N+1) + (1:N+1);
    i_aj2(j+1,:) = i_aj1(j+1,N+1) + (1:N+1);
    i_aj3(j+1,:) = i_aj2(j+1,N+1) + (1:N+1);
    i_aj4(j+1,:) = i_aj3(j+1,N+1) + (1:N+1);
end

%%%%%%%%%%%%%%%%%%%%%
%%% ||A_{tau,*}|| %%%
%%%%%%%%%%%%%%%%%%%%%

normA_tau = abs(A(i_tau,i_tau)) + sum(abs(A(i_tau,i_eta)));

for j = 1:m
    normA_tau = normA_tau + dual_nu_norm_a(A(i_tau,i_aj1(j,:)),nu) + dual_nu_norm_a(A(i_tau,i_aj2(j,:)),nu) + dual_nu_norm_a(A(i_tau,i_aj3(j,:)),nu) + dual_nu_norm_a(A(i_tau,i_aj4(j,:)),nu);
end

%%%%%%%%%%%%%%%%%%%%%
%%% ||A_{eta,*}|| %%%
%%%%%%%%%%%%%%%%%%%%%

normA_eta = norm(A(i_eta,i_tau),inf) + norm(A(i_eta,i_eta),inf);

for j = 1:m
    normA_eta = normA_eta + norm([dual_nu_norm_a(A(i_eta(1),i_aj1(j,:)),nu);dual_nu_norm_a(A(i_eta(2),i_aj1(j,:)),nu);dual_nu_norm_a(A(i_eta(3),i_aj1(j,:)),nu)],inf) ...
        + norm([dual_nu_norm_a(A(i_eta(1),i_aj1(j,:)),nu);dual_nu_norm_a(A(i_eta(2),i_aj1(j,:)),nu);dual_nu_norm_a(A(i_eta(3),i_aj1(j,:)),nu)],inf) ...
        + norm([dual_nu_norm_a(A(i_eta(1),i_aj2(j,:)),nu);dual_nu_norm_a(A(i_eta(2),i_aj2(j,:)),nu);dual_nu_norm_a(A(i_eta(3),i_aj2(j,:)),nu)],inf) ...
        + norm([dual_nu_norm_a(A(i_eta(1),i_aj3(j,:)),nu);dual_nu_norm_a(A(i_eta(2),i_aj3(j,:)),nu);dual_nu_norm_a(A(i_eta(3),i_aj3(j,:)),nu)],inf) ...
        + norm([dual_nu_norm_a(A(i_eta(1),i_aj4(j,:)),nu);dual_nu_norm_a(A(i_eta(2),i_aj4(j,:)),nu);dual_nu_norm_a(A(i_eta(3),i_aj4(j,:)),nu)],inf);
end

%%%%%%%%%%%%%%%%%%%%%%%%%
%%% ||A_{a^{(j)},*}|| %%%
%%%%%%%%%%%%%%%%%%%%%%%%%

Lambda_inv = diag([1 (1:N).^(-1)]);
T = diag(ones(1,N),-1) - diag(ones(1,N),1) ; T(1,2)=0;
M = Lambda_inv*T;

normA_a = intval(zeros(m,1));

omega = [1 2*nu.^abs(1:N)];

for k=1:m
    
    norm_A_ak_tau = norm([nu_norm_a(A(i_aj1(k,:),i_tau),nu);nu_norm_a(A(i_aj2(k,:),i_tau),nu);nu_norm_a(A(i_aj3(k,:),i_tau),nu);nu_norm_a(A(i_aj4(k,:),i_tau),nu)],inf);
    
    norm_A_ak_eta = ...
          norm([nu_norm_a(A(i_aj1(k,:),i_eta(1)),nu);nu_norm_a(A(i_aj2(k,:),i_eta(1)),nu);nu_norm_a(A(i_aj3(k,:),i_eta(1)),nu);nu_norm_a(A(i_aj4(k,:),i_eta(1)),nu)],inf) ...
        + norm([nu_norm_a(A(i_aj1(k,:),i_eta(2)),nu);nu_norm_a(A(i_aj2(k,:),i_eta(2)),nu);nu_norm_a(A(i_aj3(k,:),i_eta(2)),nu);nu_norm_a(A(i_aj4(k,:),i_eta(2)),nu)],inf) ...
        + norm([nu_norm_a(A(i_aj1(k,:),i_eta(3)),nu);nu_norm_a(A(i_aj2(k,:),i_eta(3)),nu);nu_norm_a(A(i_aj3(k,:),i_eta(3)),nu);nu_norm_a(A(i_aj4(k,:),i_eta(3)),nu)],inf);
    
    normA_a(k) = normA_a(k) + norm_A_ak_tau + norm_A_ak_eta;
    
    for j = 1:m
        n1 = max(max(sup(sum((A(i_aj1(j,:),i_aj1(k,:))*M).*repmat(omega,N+1,1)')./omega)),tail) ...
            + max(sup(sum((A(i_aj1(j,:),i_aj2(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj1(j,:),i_aj3(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj1(j,:),i_aj4(k,:))*M).*repmat(omega,N+1,1)')./omega));
        
        n2 = max(sup(sum((A(i_aj2(j,:),i_aj1(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(max(sup(sum((A(i_aj2(j,:),i_aj2(k,:))*M).*repmat(omega,N+1,1)')./omega)),tail) ...
            + max(sup(sum((A(i_aj2(j,:),i_aj3(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj2(j,:),i_aj4(k,:))*M).*repmat(omega,N+1,1)')./omega));
        
        n3 = max(sup(sum((A(i_aj3(j,:),i_aj1(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj3(j,:),i_aj2(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(max(sup(sum((A(i_aj3(j,:),i_aj3(k,:))*M).*repmat(omega,N+1,1)')./omega)),tail) ...
            + max(sup(sum((A(i_aj3(j,:),i_aj4(k,:))*M).*repmat(omega,N+1,1)')./omega));
        
        n4 = max(sup(sum((A(i_aj4(j,:),i_aj1(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj4(j,:),i_aj2(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(sup(sum((A(i_aj4(j,:),i_aj3(k,:))*M).*repmat(omega,N+1,1)')./omega)) ...
            + max(max(sup(sum((A(i_aj4(j,:),i_aj4(k,:))*M).*repmat(omega,N+1,1)')./omega)),tail);
        
        norm_Aajak = max([n1 n2 n3 n4]);
        
        normA_a(k) = normA_a(k) + norm_Aajak;
        
    end
    
end

normA = max([sup(normA_tau);sup(normA_eta);normA_a]);

end