function [t,y] = dde_integ_wright(alpha,range,his)
%Integrates Wright's equation 

tau = 1;

if size(his,1)==1
    his_x = linspace(-tau,0,length(his));
    his_y = his;
else
    his_x = his(1,:);
    his_y = his(2,:);
end

opts = ddeset('RelTol',1e-7,'AbsTol',1e-9);

F = @(t,y,Z) -alpha*Z*(1+y);

h = @(t) interp1(his_x,his_y,t);

sol = dde23(F,tau,h,range,opts);

t = [his_x(1:end-1), sol.x];
y = [his_y(1:end-1), sol.y];

end