function matrix_norm = matrix_norm(M,d,nu)

N = length(M)/d-1;

omega = [1 2*nu.^abs(1:N)];

if d == 1
    tM = M;
    matrix_norm = max(sum(abs(tM).*repmat(omega,N+1,1)')./omega);
else
    
    % We define tLambda as an (N+1)x(N+1) matrix containting the ||*||_d norm of each block
    tM = intval(zeros(N+1));
    
    for m = 0:N
        for n = 0:N
            tM(m+1,n+1) = norm(M(m*d+1:(m+1)*d,n*d+1:(n+1)*d),inf);
        end
    end
    
    matrix_norm = max(sum(abs(tM).*repmat(omega,N+1,1)')./omega);
    
end

end