clear
close all
clc

%%% The code requires Chebfun available for free at https://www.chebfun.org
%%% and INTLAB available at http://www.ti3.tu-harburg.de/rump/intlab/

%N = 40; n_plus = N - 25; nu = 1.1;
%N = 200; n_plus = N - 25; nu = 1.1;
N = 1000; n_plus = N - 25; nu = 1.01;

proof = 1;

tau = 1;
alpha = 2.350319657675625; m = 5; iterations = 20; % Parameter value at which there is period 5 orbit
%alpha = 2.717654787772703; m = 6; iterations = 21; % Parameter value at which there is period 6 orbit
%alpha = 2.984347361576818; m = 7; iterations = 44; % Parameter value at which there is period 7 orbit
%alpha =  3.198550677656422; m = 8; iterations = 20; % Parameter value at which there is period 8 orbit
%alpha =  3.378744076237641; m = 9; iterations = 30; % Parameter value at which there is period 9 orbit

chebfunpref.setDefaults('fixedLength',N+1);

%x = @(t) 1.2+t; f = chebfun(x); b = chebcoeffs(f); b(2:end) = b(2:end)/2; b2 = rand(N+1,1).*10.^(-(1:N+1)'); b(4:end) = b2(4:end); b=.1*b;
%b = 0.2*rand(N+1,1).*10.^(-(0:N)'); b0=b;
%b = [0.01;zeros(N,1)];
load b0, b=b0; b=[b;zeros(n_plus,1)];
figure
hold on

plot([0 0],[-1 3.1],'color',[0 0 0],'linewidth',1)
axis tight
t = [-tau 0];

COLOR = zeros(iterations+1,3);
for j=1:2:iterations+1
    COLOR(j,:) = [0 0 .9];
end
for j=2:2:iterations+1
    COLOR(j,:) = [.9 0 0];
end

plot_profile(b,t,COLOR(1,:))

eps0 = 0;

tot_a = zeros(length(b),iterations);

for k=1:iterations
    
    % Predictor
    a = integrate_one_step_wright(b,alpha);
    a0 = a;
    
    % Corrector
    a = Newton_F_wright_chebyshev(a0,b,alpha);
    
    disp(' ')
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    disp(['%%%%%%%%%%%%% Integration Step # ',num2str(k),' %%%%%%%%%%%%%'])
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
    
    if proof == 1
        
        C1 = isequal(k,1); %%% Only performs the C1 rigorous estimation at the first step
        
        [I,success] = int_rad_poly_step_wright(a,b,alpha,eps0,nu,C1);
        
        R_min(k) = I(1);
        
        if success ==0
            plot([-1 k],[0 0],'color',[0 0 0],'linewidth',1)
            disp('Failure with the integration step')
            return
        else
            disp('Success')
            disp(['r = ',num2str(I(1))])
        end
        
        eps0 = I(1);
        
    end
    
    b = a;
    tot_a(:,k)=a;
    t1 = -tau+k*tau;
    t2 = k*tau;
    t = [t1 t2];
    plot_profile(a,t,COLOR(k+1,:))
end

plot([-1 k],[0 0],'color',[0 0 0],'linewidth',1)
